'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Button = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _recompose = require('recompose');

var _SVGClear = require('./svg/SVGClear');

var _SVGClear2 = _interopRequireDefault(_SVGClear);

var _SVGDone = require('./svg/SVGDone');

var _SVGDone2 = _interopRequireDefault(_SVGDone);

var _SVGAdd = require('./svg/SVGAdd');

var _SVGAdd2 = _interopRequireDefault(_SVGAdd);

var _SVGRemove = require('./svg/SVGRemove');

var _SVGRemove2 = _interopRequireDefault(_SVGRemove);

var _SVGExpandLess = require('./svg/SVGExpandLess');

var _SVGExpandLess2 = _interopRequireDefault(_SVGExpandLess);

var _SVGExpandMore = require('./svg/SVGExpandMore');

var _SVGExpandMore2 = _interopRequireDefault(_SVGExpandMore);

var _helperFunctions = require('./helperFunctions');

var _defaultStyles = require('./defaultStyles');

var _SVGCancel = require('./svg/SVGCancel');

var _SVGCancel2 = _interopRequireDefault(_SVGCancel);

var _tinycolor = require('tinycolor2');

var _tinycolor2 = _interopRequireDefault(_tinycolor);

var _SVGCross = require('./svg/SVGCross');

var _SVGCross2 = _interopRequireDefault(_SVGCross);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// import {getButtonStyles} from './defaultStyles'
var Button = function Button(_ref) {
  var _ref$type = _ref.type,
      type = _ref$type === undefined ? 'default' : _ref$type,
      _ref$invert = _ref.invert,
      invert = _ref$invert === undefined ? false : _ref$invert,
      transition = _ref.transition,
      children = _ref.children,
      containerRef = _ref.containerRef,
      className = _ref.className,
      style = _ref.style,
      isOn = _ref.isOn,
      isDisabled = _ref.disabled,
      onClick = _ref.onClick,
      _onMouseOver = _ref.onMouseOver,
      _onTouchStart = _ref.onTouchStart,
      _onTouchEnd = _ref.onTouchEnd,
      _onMouseLeave = _ref.onMouseLeave,
      _onMouseDown = _ref.onMouseDown,
      _onMouseUp = _ref.onMouseUp,
      isMouseOver = _ref.isMouseOver,
      isMouseDown = _ref.isMouseDown,
      size = _ref.size,
      setIsMouseOver = _ref.setIsMouseOver,
      setIsMouseDown = _ref.setIsMouseDown,
      _ref$colors = _ref.colors,
      colors = _ref$colors === undefined ? {} : _ref$colors,
      props = (0, _objectWithoutProperties3.default)(_ref, ['type', 'invert', 'transition', 'children', 'containerRef', 'className', 'style', 'isOn', 'disabled', 'onClick', 'onMouseOver', 'onTouchStart', 'onTouchEnd', 'onMouseLeave', 'onMouseDown', 'onMouseUp', 'isMouseOver', 'isMouseDown', 'size', 'setIsMouseOver', 'setIsMouseDown', 'colors']);

  var getClassName = function getClassName(_ref2) {
    var className = _ref2.className,
        isOn = _ref2.isOn,
        isDisabled = _ref2.isDisabled;

    var baseClass = 'button button--' + type;
    var baseDisabledClass = 'button--disabled button--' + type + '--disabled';
    var baseToggleClass = 'button--' + type + '--' + (isOn ? 'on' : 'off');
    if (!isDisabled) {
      if (typeof isOn !== 'undefined') {
        if (typeof className !== 'undefined') {
          return baseClass + ' ' + baseToggleClass + ' ' + className + ' ' + className + '--' + (isOn ? 'on' : 'off');
        } else {
          return baseClass + ' ' + baseToggleClass;
        }
      } else {
        if (typeof className !== 'undefined') {
          return baseClass + ' ' + className;
        } else {
          return '' + baseClass;
        }
      }
    } else {
      if (typeof className !== 'undefined') {
        return baseClass + ' ' + baseDisabledClass + ' ' + className + ' ' + className + '--disabled';
      } else {
        return baseClass + ' ' + baseDisabledClass;
      }
    }
  };

  var getButtonProps = function getButtonProps() {
    var _ref3 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    var _onClick = _ref3.onClick,
        className = _ref3.className,
        style = _ref3.style,
        props = (0, _objectWithoutProperties3.default)(_ref3, ['onClick', 'className', 'style']);

    var transitionSwitch = transition ? transition : colors.transition;
    var getTransitionStyle = function getTransitionStyle() {
      var iOn = colors.on,
          iOff = colors.off,
          diff = colors.diff,
          disabled = colors.disabled;

      var on = void 0,
          off = void 0;
      if (invert) {
        on = iOff;
        off = iOn;
      } else {
        on = iOn;
        off = iOff;
      }
      var color = void 0,
          backgroundColor = void 0;
      if (!isDisabled) {
        switch (transitionSwitch) {
          case 'smooth':
            if (isOn) {
              if (isMouseDown && isMouseOver) {
                color = (0, _tinycolor2.default)(on.color).lighten(diff);
                backgroundColor = (0, _tinycolor2.default)(on.backgroundColor).darken(diff * 1.25);
              } else {
                if (isMouseOver) {
                  color = (0, _tinycolor2.default)(on.color).lighten(diff);
                  backgroundColor = (0, _tinycolor2.default)(on.backgroundColor).lighten(diff);
                } else {
                  color = on.color;
                  backgroundColor = on.backgroundColor;
                }
              }
            } else {
              if (isMouseDown && isMouseOver) {
                color = (0, _tinycolor2.default)(off.color).darken(diff);
                backgroundColor = (0, _tinycolor2.default)(off.backgroundColor).lighten(diff * 1.25);
              } else {
                if (isMouseOver) {
                  color = (0, _tinycolor2.default)(off.color).darken(diff);
                  backgroundColor = (0, _tinycolor2.default)(off.backgroundColor).darken(diff);
                } else {
                  color = off.color;
                  backgroundColor = off.backgroundColor;
                }
              }
            }
            return {
              color: color,
              backgroundColor: backgroundColor
            };
          case 'mix':
            var getMixedBackgroundColor = function getMixedBackgroundColor() {
              var amount = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 50;
              return _tinycolor2.default.mix(on.backgroundColor, off.backgroundColor, amount);
            };
            var getMixedColor = function getMixedColor() {
              var amount = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 50;
              return _tinycolor2.default.mix(on.color, off.color, amount);
            };
            if (isOn) {
              if (isMouseDown && isMouseOver) {
                color = (0, _tinycolor2.default)(getMixedColor()).darken(diff);
                backgroundColor = (0, _tinycolor2.default)(getMixedBackgroundColor()).darken(diff).darken(diff);
              } else {
                if (isMouseOver) {
                  color = (0, _tinycolor2.default)(getMixedColor(5));
                  backgroundColor = (0, _tinycolor2.default)(getMixedBackgroundColor(75)); //.desaturate(diff * 0.5)
                } else {
                  color = on.color;
                  backgroundColor = on.backgroundColor;
                }
              }
            } else {
              if (isMouseDown && isMouseOver) {
                color = (0, _tinycolor2.default)(getMixedColor()).darken(diff);
                backgroundColor = (0, _tinycolor2.default)(getMixedBackgroundColor()).darken(diff).darken(diff);
              } else {
                if (isMouseOver) {
                  color = (0, _tinycolor2.default)(getMixedColor(95));
                  backgroundColor = (0, _tinycolor2.default)(getMixedBackgroundColor(75)); //.desaturate(diff * 1.5)
                } else {
                  color = off.color;
                  backgroundColor = off.backgroundColor;
                }
              }
            }
            return {
              color: color,
              backgroundColor: backgroundColor
            };
          case 'text':
            return {
              color: isOn ? isMouseOver ? (0, _helperFunctions.lightenDarken)(colors.off.color, -colors.diff) : colors.on.color : isMouseOver ? (0, _helperFunctions.lightenDarken)(colors.on.color, colors.diff) : colors.off.color
            };
          case 'backgroundColor':
            return {
              backgroundColor: isOn ? isMouseOver ? (0, _helperFunctions.lightenDarken)(colors.off.backgroundColor, -colors.diff) : colors.on.backgroundColor : isMouseOver ? (0, _helperFunctions.lightenDarken)(colors.on.backgroundColor, colors.diff) : colors.off.backgroundColor
            };
          case 'contrast':
            if (isOn) {
              if (isMouseDown && isMouseOver) {
                color = (0, _tinycolor2.default)(off.color).darken(diff * 0.5);
                backgroundColor = (0, _tinycolor2.default)(off.backgroundColor).darken(diff * 0.5);
              } else {
                if (isMouseOver) {
                  color = (0, _tinycolor2.default)(off.color).lighten(diff);
                  backgroundColor = (0, _tinycolor2.default)(off.backgroundColor).lighten(diff);
                } else {
                  color = on.color;
                  backgroundColor = on.backgroundColor;
                }
              }
            } else {
              if (isMouseDown && isMouseOver) {
                color = (0, _tinycolor2.default)(on.color).darken(diff * 0.5);
                backgroundColor = (0, _tinycolor2.default)(on.backgroundColor).darken(diff * 0.5);
              } else {
                if (isMouseOver) {
                  color = (0, _tinycolor2.default)(on.color).lighten(diff);
                  backgroundColor = (0, _tinycolor2.default)(on.backgroundColor).lighten(diff);
                } else {
                  color = off.color;
                  backgroundColor = off.backgroundColor;
                }
              }
            }
            return {
              color: color,
              backgroundColor: backgroundColor
            };
          default:
            break;
        }
      } else {
        return {
          color: disabled && disabled.color ? disabled.color : _defaultStyles.buttonStyles.neutral.disabled.color,
          backgroundColor: disabled && disabled.backgroundColor ? disabled.backgroundColor : _defaultStyles.buttonStyles.neutral.disabled.backgroundColor
        };
      }
    };
    var getSize = function getSize() {
      switch (size) {
        case 's':
          return { padding: '0.25rem 0.5rem', fontSize: '1.25rem' };
        case 'l':
          return { padding: '0.75rem 1rem', fontSize: '1.75rem' };
        case 'm':
        default:
          return { padding: '0.5rem 0.75rem', fontSize: '1.5rem' };
      }
    };
    var getDefaultStyle = function getDefaultStyle() {
      return (0, _extends3.default)({
        display: 'flex',
        //fontFamily: `Arial, sans-serif`,
        alignItems: 'center',
        justifyContent: 'center',
        transition: 'all 250ms ease-in-out',

        cursor: 'pointer'
      }, getSize(), getTransitionStyle());
    };
    if (isDisabled) {
      return {
        style: (0, _extends3.default)({}, getDefaultStyle(), style),
        className: getClassName({ className: className, isOn: isOn, isDisabled: isDisabled })
      };
    }
    return (0, _extends3.default)({
      style: (0, _extends3.default)({}, getDefaultStyle(), style),
      onClick: function onClick(e) {
        for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
          args[_key - 1] = arguments[_key];
        }

        e.stopPropagation();
        _onClick && _onClick.apply(undefined, [e].concat(args));
        //setIsMouseOver(false)
      },
      onMouseOver: function onMouseOver(e) {
        for (var _len2 = arguments.length, args = Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
          args[_key2 - 1] = arguments[_key2];
        }

        _onMouseOver && _onMouseOver.apply(undefined, [e].concat(args));
        setIsMouseOver(true);
      },
      onMouseLeave: function onMouseLeave(e) {
        for (var _len3 = arguments.length, args = Array(_len3 > 1 ? _len3 - 1 : 0), _key3 = 1; _key3 < _len3; _key3++) {
          args[_key3 - 1] = arguments[_key3];
        }

        _onMouseLeave && _onMouseLeave.apply(undefined, [e].concat(args));
        setIsMouseOver(false);
        setIsMouseDown(false);
      },
      onMouseDown: function onMouseDown(e) {
        for (var _len4 = arguments.length, args = Array(_len4 > 1 ? _len4 - 1 : 0), _key4 = 1; _key4 < _len4; _key4++) {
          args[_key4 - 1] = arguments[_key4];
        }

        _onMouseDown && _onMouseDown.apply(undefined, [e].concat(args));
        setIsMouseDown(true);
      },
      onMouseUp: function onMouseUp(e) {
        for (var _len5 = arguments.length, args = Array(_len5 > 1 ? _len5 - 1 : 0), _key5 = 1; _key5 < _len5; _key5++) {
          args[_key5 - 1] = arguments[_key5];
        }

        _onMouseUp && _onMouseUp.apply(undefined, [e].concat(args));
        setIsMouseDown(false);
      },
      onTouchStart: function onTouchStart(e) {
        for (var _len6 = arguments.length, args = Array(_len6 > 1 ? _len6 - 1 : 0), _key6 = 1; _key6 < _len6; _key6++) {
          args[_key6 - 1] = arguments[_key6];
        }

        _onTouchStart && _onTouchStart.apply(undefined, [e].concat(args));
      },
      onTouchEnd: function onTouchEnd(e) {
        for (var _len7 = arguments.length, args = Array(_len7 > 1 ? _len7 - 1 : 0), _key7 = 1; _key7 < _len7; _key7++) {
          args[_key7 - 1] = arguments[_key7];
        }

        _onTouchEnd && _onTouchEnd.apply(undefined, [e].concat(args));
      },
      className: getClassName({ className: className, isOn: isOn, isDisabled: isDisabled })
    }, props);
  };
  var renderChildren = function renderChildren(type) {
    var icon = void 0;
    var renderIcon = void 0;
    switch (type) {
      case 'caretdropdown':
        icon = isOn ? _react2.default.createElement(_SVGExpandLess2.default, { style: { pointerEvents: 'none' } }) : _react2.default.createElement(_SVGExpandMore2.default, { style: { pointerEvents: 'none' } });
        renderIcon = function renderIcon(props) {
          return isOn ? _react2.default.createElement(_SVGExpandLess2.default, (0, _extends3.default)({ style: { pointerEvents: 'none' } }, props)) : _react2.default.createElement(_SVGExpandMore2.default, (0, _extends3.default)({ style: { pointerEvents: 'none' } }, props));
        };
        return typeof children === 'function' ? children({ getButtonProps: getButtonProps, isMouseOver: isMouseOver, icon: icon, renderIcon: renderIcon }) : _react2.default.createElement(
          'div',
          (0, _extends3.default)({}, getButtonProps({
            onClick: onClick,
            className: className,
            style: (0, _extends3.default)({ justifyContent: 'space-between' }, style)
          })),
          children ? _react2.default.createElement(
            _react.Fragment,
            null,
            _react2.default.createElement(
              'div',
              { style: { display: 'flex', justifyContent: 'space-between' } },
              children
            ),
            renderIcon({ style: { pointerEvents: 'none', marginLeft: '0.75rem' } })
          ) : renderIcon({ style: { pointerEvents: 'none' } })
        );
      case 'cancel':
        icon = _react2.default.createElement(_SVGCross2.default, { viewBox: '0 0 20 20', size: 16 });
        renderIcon = function renderIcon(props) {
          return _react2.default.createElement(_SVGCross2.default, (0, _extends3.default)({ viewBox: '0 0 20 20', size: 16 }, props));
        };
        return typeof children === 'function' ? children({ getButtonProps: getButtonProps, isMouseOver: isMouseOver, icon: icon }) : _react2.default.createElement(
          'div',
          (0, _extends3.default)({}, getButtonProps({
            onClick: onClick,
            className: className,
            style: (0, _extends3.default)({ justifyContent: 'center', alignItems: 'center' }, style)
          })),
          children ? _react2.default.createElement(
            _react.Fragment,
            null,
            _react2.default.createElement(
              'div',
              { style: { display: 'flex', justifyContent: 'space-between' } },
              children
            ),
            renderIcon({ style: { pointerEvents: 'none', marginLeft: '0.75rem' } })
          ) : renderIcon({ style: { pointerEvents: 'none' } })
        );
      default:
        return typeof children === 'function' ? children({ getButtonProps: getButtonProps, isMouseOver: isMouseOver }) : _react2.default.createElement(
          'div',
          (0, _extends3.default)({}, getButtonProps((0, _extends3.default)({ onClick: onClick, className: className, style: style }, props))),
          children
        );
    }
  };

  return renderChildren(type);
};

exports.Button = Button;
Button.defaultProps = {
  colors: _defaultStyles.buttonStyles.neutral
};

var enhance = (0, _recompose.compose)((0, _recompose.withState)('isMouseOver', 'setIsMouseOver', false), (0, _recompose.withState)('isMouseDown', 'setIsMouseDown', false), (0, _recompose.setPropTypes)({
  //children: PropTypes.oneOfType([PropTypes.node, PropTypes.func]).isRequired,
  type: _propTypes2.default.string,
  onClick: _propTypes2.default.func,
  isMouseOver: _propTypes2.default.bool.isRequired,
  setIsMouseOver: _propTypes2.default.func.isRequired
}), (0, _recompose.onlyUpdateForKeys)(['isOn', 'isMouseOver', 'isMouseDown', 'children', 'disabled']));

exports.default = enhance(Button);