'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.LanguagePicker = undefined;

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _recompose = require('recompose');

var _helperFunctions = require('./helperFunctions');

var _defaultStyles = require('./defaultStyles');

var _settings = require('./utilities/settings');

var _DropdownPopover = require('./DropdownPopover');

var _DropdownPopover2 = _interopRequireDefault(_DropdownPopover);

var _Button = require('./Button');

var _Button2 = _interopRequireDefault(_Button);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var LanguagePicker = exports.LanguagePicker = function LanguagePicker(_ref) {
  var languages = _ref.languages,
      setActiveLanguage = _ref.setActiveLanguage,
      activeLanguage = _ref.activeLanguage,
      style = _ref.style,
      callback = _ref.callback;

  return _react2.default.createElement(
    _DropdownPopover2.default,
    {
      style: style,
      triggerX: 2.5,
      basewidth: 4,
      renderTrigger: function renderTrigger(_ref2) {
        var getTriggerProps = _ref2.getTriggerProps;
        return _react2.default.createElement(
          _Button2.default,
          getTriggerProps({ style: { width: '2.5rem' } }),
          _react2.default.createElement('img', { style: { width: '2.5rem' }, src: _settings.flags[activeLanguage] })
        );
      },
      parentName: 'languagepicker'
    },
    function (_ref3) {
      var toggle = _ref3.toggle,
          rtgStyle = _ref3.rtgStyle,
          className = _ref3.className;
      return _react2.default.createElement(
        'div',
        {
          style: rtgStyle,
          className: className
        },
        languages.map(function (language) {
          return _react2.default.createElement(
            _Button2.default,
            {
              colors: _defaultStyles.buttonStyles.verdant,
              isOn: activeLanguage === language.code,
              key: language.code,
              style: { width: '2.5rem' },
              className: (0, _helperFunctions.flippyClass)(activeLanguage === language.code, 'languagepicker__item', 'active', 'inactive'),
              onClick: function () {
                var _ref4 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
                  return _regenerator2.default.wrap(function _callee$(_context) {
                    while (1) {
                      switch (_context.prev = _context.next) {
                        case 0:
                          _context.next = 2;
                          return setActiveLanguage(language.code);

                        case 2:
                          if (!callback) {
                            _context.next = 5;
                            break;
                          }

                          _context.next = 5;
                          return callback(language.code);

                        case 5:
                          toggle();

                        case 6:
                        case 'end':
                          return _context.stop();
                      }
                    }
                  }, _callee, undefined);
                }));

                function onClick() {
                  return _ref4.apply(this, arguments);
                }

                return onClick;
              }()
            },
            _react2.default.createElement('img', { src: _settings.flags[language.code] })
          );
        })
      );
    }
  );
};

LanguagePicker.propTypes = {
  languages: _propTypes2.default.array.isRequired,
  activeLanguage: _propTypes2.default.string.isRequired,
  setActiveLanguage: _propTypes2.default.func.isRequired
};

var enhance = (0, _recompose.compose)();
//  onlyUpdateForKeys([`activeLanguage`])

exports.default = enhance(LanguagePicker);